#! /usr/bin/perl -w

$host = "localhost";      # Enter the IP address of the server machine
                          # Set to localhost to easily test on one box

# Create new blank log
$log="logsearch.doc";
open (EP, "> $log") || die "Error: can't open log file: $!";
print (EP "");
close (EP) || die "Error: can't close log file: $!";

use IO::Socket::INET;
print "LogSearch v1 - Client program\n\n";
print "Enter the flag you want to search for then press enter.\n";
print "Enter \"svrexit\" to close the server program.\n";
print "Enter \"exit\" to close just the client program. \n";
print "Enter \"rmlogs\" to remove logs on server (IIS only). \n";

# Set sending port to send flags
$sendSocket=new IO::Socket::INET->new(

	PeerPort=>1778,
	Proto=>'udp',
	PeerAddr=>$host
)
or die "can't bind sendSocket: $@\n";

# Set listening port to collect data
$listenSocket=new IO::Socket::INET->new(

	LocalPort=>1777,
	Proto=>'udp'
)
or die "can't bind listenSocket: $@\n";

# Prompt user for flag to send
$prompt="Enter flag to send to server : ";
print "\n",$prompt;

while($flag=<STDIN>) {
	chomp $flag;

        # If user wants to exit the client
	if($flag eq 'exit') { print "\nThe client has exited...\n"; exit; }

        # If user tries to send empty flag to server
	if($flag eq ''){ print "\nYou must enter a flag to send...\n\n"; print $prompt; }

        #If user sent a valid flag
	else { 
        	# If user sends 'svrexit' flag the server will close 
        	if($flag eq 'svrexit') { 
                         print "\nThe server has exited...\n";
                         print "\nYou will need to restart the server to run logSearch.\n";
                         print "The client program will close in 5 seconds..."; 
                } 

                print "\nSending flag to server: '",$flag,"'";

        	if($sendSocket->send($flag)) {
                        if($flag eq 'svrexit'){ sleep(5); die; }

                        # If user sent search flag then listen for and log results
			$listenSocket->recv($data,10000000);

			# 'trim' data
			$data =~ s/^\s+//;
			$data =~ s/\s+$//;

                        if($data eq '') { 
               		        print "\n * Flag was successfully sent","\n\n";
				print "There was nothing that matched your flag: '",$flag,"'\n\n";
				print $prompt; 
			}
 			else {
				open (EP, ">> $log") || die "Error: can't open log file: $!";
					print (EP "$data \n");
					print (EP "=======================================END\n");
				close (EP) || die "Error: can't close log file: $!";
                		print "\n * Flag was successfully sent","\n\n";
                		print "Your data has been logged to $log\n\n";
            			print $prompt;

			}
        	}
                else { print "Error sending flag to server.\n"; die; }
    	}

}
